/*
* Jalview - A Sequence Alignment Editor and Viewer
* Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/
package MCview;

import java.awt.*;


public class Atom {
    float x;
    float y;
    float z;
    int number;
    String name;
    String resName;
    int resNumber;
    int type;
    Color color;
    String chain;
    int alignmentMapping=-1;

    public boolean isSelected = false;

    public Atom(String str)
    {
        name =  str.substring(12,15).trim();

        resName = str.substring(17,20);

        chain = str.substring(21,22);

        resNumber = Integer.parseInt(str.substring(22,26).trim());

        this.x = (float) (new Float(str.substring(30,38).trim()).floatValue());
        this.y = (float) (new Float(str.substring(38,46).trim()).floatValue());
        this.z = (float) (new Float(str.substring(47,55).trim()).floatValue());

    }

    public void setColor(Color col) {
        this.color = col;
    }
}
