/*
 * Jalview - A Sequence Alignment Editor and Viewer
 * Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

package jalview.appletgui;

import java.util.*;

import java.awt.event.*;

import jalview.analysis.*;
import jalview.datamodel.*;
import java.awt.*;

public class PairwiseAlignPanel
    extends Panel implements ActionListener
{
  Vector sequences = new Vector();
  AlignmentPanel ap;

  public PairwiseAlignPanel(AlignmentPanel ap)
  {
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
  }
    this.ap = ap;
    float scores[][] = new float[ap.av.alignment.getHeight()][ap.av.alignment.
        getHeight()];
    double totscore = 0;
    int count = ap.av.getSelectionGroup().getSize();

    int acount = 0;
    for (int i = 1; i < count; i++)
    {
      for (int j = 0; j < i; j++)
      {
        acount++;
        AlignSeq as = new AlignSeq(ap.av.getSelectionGroup().getSequenceAt(i),
                                   ap.av.getSelectionGroup().getSequenceAt(j),
                                   "pep");

        as.calcScoreMatrix();
        as.traceAlignment();
        as.printAlignment(System.out);
        scores[i][j] = (float) as.getMaxScore() / (float) as.getASeq1().length;
        totscore = totscore + scores[i][j];

        textarea.append(as.getOutput());
        sequences.addElement(new Sequence(as.getS1().getName(), as.getAStr1()));
        sequences.addElement(new Sequence(as.getS2().getName(), as.getAStr2()));

      }
    }

    if (count > 2)
    {
      for (int i = 0; i < count; i++)
      {
        for (int j = 0; j < i; j++)
        {
          jalview.util.Format.print(System.out, "%7.3f",
                                    scores[i][j] / totscore);
        }
      }
    }
  }

  public void actionPerformed(ActionEvent evt)
  {
    if(evt.getSource()==viewInEditorButton)
      viewInEditorButton_actionPerformed();
  }

  protected void viewInEditorButton_actionPerformed()
  {

    Sequence[] seq = new Sequence[sequences.size()];

    for (int i = 0; i < sequences.size(); i++)
    {
      seq[i] = (Sequence) sequences.elementAt(i);
    }

    new AlignFrame(new Alignment(seq),
                                   ap.alignFrame.applet,
                                   "Pairwise Aligned Sequences",
                                   false);

  }
  protected ScrollPane scrollPane = new ScrollPane();
  protected TextArea textarea = new TextArea();
  protected Button viewInEditorButton = new Button();
  Panel jPanel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();

  private void jbInit() throws Exception {
      this.setLayout(borderLayout1);
      textarea.setFont(new java.awt.Font("Monospaced", 0, 12));
      textarea.setText("");
      viewInEditorButton.setFont(new java.awt.Font("Verdana", 0, 12));
      viewInEditorButton.setLabel("View in alignment editor");
      viewInEditorButton.addActionListener(this);
      this.add(scrollPane, BorderLayout.CENTER);
      scrollPane.add(textarea);
      this.add(jPanel1, BorderLayout.SOUTH);
      jPanel1.add(viewInEditorButton, null);
  }

}
