/*
 * Jalview - A Sequence Alignment Editor and Viewer
 * Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package jalview.datamodel;

/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision: 1.11 $
 */
public class SequenceFeature
{
    public int position;
    public int begin;
    public int end;
    public String type;
    public String description;
    public String status;

    // Feature group can be set from a features file
    // as a group of features between STARTGROUP and ENDGROUP markers
    public String featureGroup;

    public SequenceFeature()
    {}

    public SequenceFeature(String type,
                           String desc,
                           String status,
                           int begin, int end,
                           String featureGroup)
    {
      this.type = type;
      this.description = desc;
      this.status = status;
      this.position = begin;
      this.begin = begin;
      this.end = end;
      this.featureGroup = featureGroup;
    }

    public boolean equals(SequenceFeature sf)
    {
      if(begin != sf.begin
      || end != sf.end)
     return false;


      if(!(type+description+status).equals
         (sf.type+sf.description+sf.status))
        return false;

      return true;
    }


    public int getPosition()
    {
      return position;
    }

    public void setPosition(int pos)
    {
      position = pos;
      begin = pos;
      end = pos;
    }


    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getBegin()
    {
        return begin;
    }

    public void setBegin(int start)
    {
      this.begin = start;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getEnd()
    {
        return end;
    }

    public void setEnd(int end)
    {
      this.end = end;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getType()
    {
        return type;
    }

    public void setType(String type)
    {
      this.type = type;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getDescription()
    {
        return description;
    }

    public void setDescription(String desc)
    {
      description = desc;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getStatus()
    {
        return status;
    }

    public void setStatus(String status)
    {
      this.status = status;
    }

    public String getFeatureGroup()
    {
      return featureGroup;
    }

    public void setFeatureGroup(String featureGroup)
    {
      this.featureGroup = featureGroup;
    }


}
